const _Http = getApp().globalData.http;
let sa_brandid = null,
  sys_enterpriseid = null;
import {
  fileList
} from "../../utils/FormatTheAttachment";
import currency from "../../utils/currency";

Page({
  data: {
    loading: true
  },
  onLoad(options) {
    if (options.id) this.setData({
      sa_itemgroupid: options.id,
      itemno: options.itemno
    })
    sa_brandid = options.sa_brandid;
    this.setData({
      userrole: wx.getStorageSync('userrole')
    })

    if (wx.getStorageSync('userrole') == '业务员') sys_enterpriseid = options.sys_enterpriseid
    this.getDetail();
  },
  /* 获取详情 */
  getDetail() {
    let content = {
      "sa_itemgroupid": this.data.sa_itemgroupid,
      pageSize: 999
    }
    if (sys_enterpriseid) content.sys_enterpriseid = sys_enterpriseid;
    console.log(sys_enterpriseid)
    _Http.basic({
      "id": "20220926142403",
      content
    }).then(res => {
      console.log("商品详情", res)
      if (res.msg != '成功') return wx.showToast({
        title: res.msg,
        icon: "none"
      })
      if (res.data.length == 0) {
        wx.showToast({
          title: '未查询到商品',
          icon: "none",
          mask: true
        })
        setTimeout(() => {
          wx.navigateBack();
        }, 500)
        return;
      }
      this.handleFiles(res.data[0].attinfos)
      const CNY = sum => currency(sum, {
        symbol: "￥",
        precision: 2
      }).format();

      this.setData({
        detail: res.data[0],
        rows: res.data.map(v => {
          v.gradeprice = CNY(v.gradeprice);
          v.marketprice = CNY(v.marketprice);
          return v
        }),
        loading: false
      })
    })
  },
  /* 预览媒体 */
  viewMedias(e) {
    const {
      index,
      type
    } = e.currentTarget.dataset;
    wx.previewMedia({
      current: index,
      sources: type == 'image' ? this.data.files.viewImages : this.data.files.viewVideos,
    })
  },
  /* 处理附件 */
  handleFiles(arr) {
    let files = {
        images: [],
        viewImages: [],
        videos: [],
        viewVideos: [],
        files: []
      },
      list = fileList(arr);
    list.forEach(v => {
      switch (v.fileType) {
        case "video":
          files.videos.push(v)
          files.viewVideos.push({
            url: v.url,
            type: "video",
            poster: v.subfiles[0].url
          })
          break;
        case "image":
          files.images.push(v)
          files.viewImages.push({
            url: v.url,
            type: "image"
          })
          break;
        default:
          files.files.push(v)
          break;
      }
    });
    this.setData({
      files
    })
  },
  /* 切换产品 */
  changeItemno(e) {
    const {
      item
    } = e.currentTarget.dataset;
    if (item.itemno == this.data.itemno) return;
    this.handleFiles(item.attinfos)
    this.setData({
      detail: item,
      itemno: item.itemno
    })
  },
  clickBut() {
    this.data.detail.tradefield.length >= 2 ? wx.showToast({
      title: '请选择加入产品领域',
      icon: "none",
      duration: 3000
    }) : this.handleStorage(0);
  },
  /* 打开文档 */
  openDocument(e) {
    const {
      item
    } = e.currentTarget.dataset;
    console.log(item)
    wx.showLoading({
      title: '加载中...',
      mask: true,
    })
    wx.downloadFile({
      url: item.url,
      success: function (res) {
        const filePath = res.tempFilePath
        wx.openDocument({
          filePath: filePath,
          showMenu: true,
          fileType: item.postfix,
          success: function (res) {
            wx.hideLoading();
            console.log('打开文档成功')
          },
          fail(e) {
            console.log(e)
            wx.showToast({
              title: '打开失败',
              icon: "error",
              mask: true
            })
          }
        })
      },
      fail(e) {
        console.log(e)
        wx.showToast({
          title: '打开失败',
          icon: "error",
          mask: true
        })
      }
    })
  },
  /* 选择领域 */
  storage(e) {
    this.handleStorage(e.detail.value)
  },
  handleStorage(index) {
    let detail = this.data.detail;
    _Http.basic({
      "id": 20220924095102,
      "content": {
        sa_brandid,
        "itemid": detail.itemid, //货品id
        "qty": detail.orderminqty, //数量
        "itemno": this.data.itemno, //货品编号
        tradefield: detail.tradefield[index].tradefield
      },
    }).then(res => {
      console.log("加入购物车", res)
      if (res.msg != '成功') return wx.showToast({
        title: res.msg,
        icon: "none"
      });
      _Http.basic({
        "id": 20220927093202,
        "content": {}
      }, false).then(res => {
        console.log("购物车数量", res)
        getApp().globalData.num = res.data.num;
        if (this.data.userrole == '经销商') this.selectComponent("#Float").setNum(res.data.num)
        setTimeout(() => {
          wx.showToast({
            title: '加入成功',
            icon: "none",
            icon: "none"
          });
        }, 200);
      });
    })
  },
  onShow() {
    if (this.data.userrole == '经销商') this.selectComponent("#Float").setNum(getApp().globalData.num)
  },
})